package bdchain.api;

import bdchain.api.grpc.GetLedgersResponse;
import bdchain.api.grpc.TransactionType;

public class Test {
  public static void main(String[] args) throws InterruptedException {

    final String ledger = "test";
    final int block_number = 1;
    final String block_hash = "0x0";
    final int index = 0;

    TransactionLedgerClient tlClient = new TransactionLedgerClient("localhost", 8004);
    System.out.println(tlClient.createLedgerSync(ledger).getOk());
    GetLedgersResponse r = tlClient.getLedgersSync();
    for (int i = 0; i < r.getLedgersCount(); i++) {
      System.out.println(r.getLedgers(i));
    }
    System.out.println(
        tlClient
            .sendTransactionSync(ledger, TransactionType.RECORD, "0x0", "0x1", "data".getBytes())
            .getHash());
    tlClient.shutdown();

    AccountingChainClient acClient = new AccountingChainClient("localhost", 8013);
    System.out.println(acClient.blockNumberSync(ledger).getBlockNumber());
    System.out.println(acClient.getBlockByNumberSync(ledger, block_number, false).toString());
    System.out.println(acClient.getBlockByNumberSync(ledger, block_number, true).toString());
    System.out.println(acClient.getBlockByHashSync(ledger, block_hash, false).toString());
    System.out.println(acClient.getBlockByHashSync(ledger, block_hash, true).toString());
    System.out.println(acClient.getTransactionByHashSync(ledger, "0x0").toString());
    System.out.println(
        acClient.getTransactionByBlockNumberAndIndexSync(ledger, block_number, index).toString());
    System.out.println(
        acClient.getTransactionByBlockHashAndIndexSync(ledger, block_hash, index).toString());
    acClient.shutdown();
  }
}
